using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Canvas
{
    public partial class frmKind : Form
    {
        public frmKind()
        {
            InitializeComponent();
            SetOptimalSize();
            btm = new Bitmap(width, heigth);
            g = Graphics.FromImage(btm);
            Grf = new Canvas(width, heigth, g);
            #region Vorgaben zum Drucken
            printDocument.DefaultPageSettings.Landscape = true;
            System.Drawing.Printing.Margins margin = new System.Drawing.Printing.Margins();
            margin.Left = (int)printDocument.DefaultPageSettings.HardMarginX;
            margin.Top = (int)printDocument.DefaultPageSettings.HardMarginY;
            float druckBreite;
            float druckHoehe;
            if (printDocument.DefaultPageSettings.Landscape == true)
            {
                // Querformat
                druckBreite = printDocument.DefaultPageSettings.PrintableArea.Height;
                druckHoehe = printDocument.DefaultPageSettings.PrintableArea.Width;
            }
            else
            {
                // Hochformat
                druckBreite = printDocument.DefaultPageSettings.PrintableArea.Width;
                druckHoehe = printDocument.DefaultPageSettings.PrintableArea.Height;
            }
            margin.Right = (int)(printDocument.DefaultPageSettings.Bounds.Width - margin.Left - druckBreite);
            margin.Bottom = (int)(printDocument.DefaultPageSettings.Bounds.Height - margin.Top - druckHoehe);
            printDocument.DefaultPageSettings.Margins = margin;
            #endregion




            PictureBox.MouseMove += new MouseEventHandler(PictureBox_MouseMove);
            PictureBox.MouseDown += new MouseEventHandler(PictureBox_MouseDown);
            PictureBox.MouseDoubleClick += new MouseEventHandler(PictureBox_MouseDoubleClick);
            PictureBox.MouseUp += new MouseEventHandler(PictureBox_MouseUp);
            Grf.DrawNew();
        }
        private int width;
        private Bitmap btm;
        private Graphics g;
        private int heigth;
        private void ScrollBarsEdit()
        {
            if (heigth > PictureBox.ClientRectangle.Height)
            {
                vSB.Enabled = true;
                vSB.Visible = true;
                vSB.Minimum = 0;
                vSB.Maximum = heigth - PictureBox.ClientRectangle.Height;
            }
            else
            {
                vSB.Value = 0;
                vSB.Enabled = false;
                vSB.Visible = false;

            }
            if (width > PictureBox.ClientRectangle.Width)
            {
                hSB.Enabled = true;
                hSB.Visible = true;
                hSB.Minimum = 0;
                hSB.Maximum = width - PictureBox.ClientRectangle.Width;
            }
            else
            {
                hSB.Value = 0;
                hSB.Enabled = false;
                hSB.Visible = false;
            }

        }
        private void SetOptimalSize()
        {
            int h = Screen.PrimaryScreen.Bounds.Height;
            int b = Screen.PrimaryScreen.Bounds.Width;
            width = (int)(b * 0.99);
            heigth = (int)(width / 1.414);
        }
        private void Kind_Activated(object sender, EventArgs e)
        {
            DrawNew();
        }
        private void Kind_Paint(object sender, PaintEventArgs e)
        {
            this.ScrollBarsEdit();
        }
        private void Kind_Resize(object sender, EventArgs e)
        {
            this.ScrollBarsEdit();
        }
        private void PictureBox_Paint(object sender, PaintEventArgs e)
        {
            Rectangle srcRect = new Rectangle(hSB.Value, vSB.Value, hSB.Value + PictureBox.ClientRectangle.Width, vSB.Value + PictureBox.ClientRectangle.Height);
            e.Graphics.DrawImage(btm, 0, 0, srcRect, GraphicsUnit.Pixel);
            switch (Grf.State)
            {
                case Canvas.GraficState.grfSelect:
                    if ((Grf.NumberOfSelectedObjects() > 0) & (FirstMove == false))
                    {
                        for (int i = 0; i < Grf.NumberOfSelectedObjects(); i++)
                        {
                            if (Grf.FigureTemp[i].Visible == true)
                            {
                                Grf.FigureTemp[i].Draw(e.Graphics);
                            }
                        }
                    }
                    break;
                case Canvas.GraficState.grfDraw:
                    if (FirstMove == false)
                    {
                        if (Grf.FigureTemp[0].Visible == true)
                        {
                            Grf.FigureTemp[0].Draw(e.Graphics);
                        }
                    }
                    break;
                default:
                    break;
            }
        }
        private void vSB_ValueChanged(object sender, EventArgs e)
        {
            this.Refresh();
        }
        private void DrawNew()
        {
            Grf.DrawNew();
            PictureBox.Refresh();
        }
        private Canvas Grf;
        private int oldX;
        private int oldY;
        private int nr;
        private int drawStep;
        private Boolean FirstMove = true;
        public int DrawStep
        {
            get
            { 
                return drawStep;
            }
            set
            {
                drawStep=value;
            }

        }
        private void PictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                switch (Grf.State)
                {
                    case Canvas.GraficState.grfNormal:
                    case Canvas.GraficState.grfSelect:
                        {
                            oldX = e.X;
                            oldY = e.Y;
                            if ((Grf.State == Canvas.GraficState.grfSelect) && (Grf.NumberOfSelectedObjects() == 1) && ((nr = Grf.Figure[Grf.SelectedObjects()[0]].CheckForObjectArea(e.X + hSB.Value, e.Y + vSB.Value)) > -1))
                            {
                                Grf.Figure[Grf.SelectedObjects()[0]].State = BasicObject.StateTyp.edit;
                            }
                            else if ((Grf.State == Canvas.GraficState.grfSelect) && (Grf.NumberOfSelectedObjects() == 1) && ((nr = Grf.Figure[Grf.SelectedObjects()[0]].CheckForObjectArea(e.X + hSB.Value, e.Y + vSB.Value)) == -2))
                            {
                                Grf.Figure[Grf.SelectedObjects()[0]].State = BasicObject.StateTyp.rotate;
                            }
                            else
                            {
                                if (Control.ModifierKeys == Keys.Control) // Strg-Taste gedrckt
                                {
                                    for (int i = 1; i < Grf.NumberOfObjects + 1; i++)
                                    {
                                        if (Grf.Figure[Grf.NumberOfObjects - i].CheckForObject(e.X + hSB.Value, e.Y + vSB.Value) == true)
                                        {
                                            if (Grf.Figure[Grf.NumberOfObjects - i].State == BasicObject.StateTyp.select)
                                            {
                                                Grf.Figure[Grf.NumberOfObjects - i].State = BasicObject.StateTyp.normal;
                                            }
                                            else
                                            {
                                                Grf.Figure[Grf.NumberOfObjects - i].State = BasicObject.StateTyp.select;
                                            }
                                            if (Grf.NumberOfSelectedObjects() > 0)
                                            {
                                                Grf.State = Canvas.GraficState.grfSelect;
                                            }
                                            else
                                            {
                                                Grf.State = Canvas.GraficState.grfNormal;
                                            }
                                        }
                                    }
                                }
                                else // Strg-Taste nicht gedrckt
                                {
                                    Grf.DeselectAll();
                                    
                                    Grf.State = Canvas.GraficState.grfNormal;
                                    for (int i = 1; i < Grf.NumberOfObjects + 1; i++)
                                    {
                                        if (Grf.Figure[Grf.NumberOfObjects - i].CheckForObject(e.X + hSB.Value, e.Y + vSB.Value) == true)
                                        {
                                            Grf.Figure[Grf.NumberOfObjects - i].State = BasicObject.StateTyp.select;
                                            Grf.State = Canvas.GraficState.grfSelect;
                                            break;
                                        }
                                    }
                                }
                                DrawNew();
                            }
                            break;
                        }
                    case Canvas.GraficState.grfDraw:
                        {
                            if (Grf.FigureTemp[0].NumberOfKnownPoints == true)
                            {
                                // Objekte mit definierter Punktzahl
                                DrawStep = ++DrawStep;
                                PointF Punkt = new PointF(e.X, e.Y);
                                for (int i = DrawStep; i < Grf.FigureTemp[0].NumberOfPoints + 1; i++)
                                {
                                    Grf.FigureTemp[0].SetPoint(Punkt, i - 1);
                                }
                                Grf.FigureTemp[0].Visible = true;
                            }
                            else
                            {
                                // Objekte mit nicht definierter Punktzahl 
                                DrawStep = ++DrawStep;
                                Grf.FigureTemp[0].NumberOfPoints = DrawStep;
                                PointF Punkt = new PointF(e.X, e.Y);
                                Grf.FigureTemp[0].SetPoint(Punkt, DrawStep - 1);
                                Grf.FigureTemp[0].SetPoint(Punkt, DrawStep);
                                Grf.FigureTemp[0].Visible = true;
                            }
                            DrawNew();
                            break;
                        }
                } // Ende switch
            }
            else if (e.Button == MouseButtons.Right)
            {
                switch (Grf.State)
                {
                    case Canvas.GraficState.grfSelect:
                        {
                            if (Grf.NumberOfSelectedObjects() == 1)
                            {
                                contextMenu.Show(new Point(e.X, e.Y));
                            }
                            break;
                        }
                    case Canvas.GraficState.grfDraw:
                        {
                            Grf.State = Canvas.GraficState.grfNormal;
                            DrawNew();
                            break;
                        }
                }
            }
        }
        private void PictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            switch (Grf.State)
            {
                case Canvas.GraficState.grfNormal:
                    {

                        break;
                    }
                case Canvas.GraficState.grfDraw:
                    {
                        if (FirstMove == true)
                        {
                            FirstMove = false;
                        }
                        else
                        {
                            PointF Punkt = new PointF(e.X, e.Y);
                            if (Grf.FigureTemp[0].NumberOfKnownPoints == true)
                            {
                                for (int i = DrawStep; i < Grf.FigureTemp[0].NumberOfPoints; i++)
                                {
                                    Grf.FigureTemp[0].SetPoint(Punkt, i);
                                    PictureBox.Refresh();
                                }
                            }
                            else
                            {
                                if (DrawStep > 0)
                                {
                                    Grf.FigureTemp[0].SetPoint(Punkt, DrawStep);
                                    PictureBox.Refresh();
                                }
                            }
                        }
                        break;
                    }
                case Canvas.GraficState.grfSelect:
                    {
                        if (e.Button == MouseButtons.Left)
                        {
                            if (FirstMove == true)
                            {
                                FirstMove = false;
                                for (int i = 0; i < Grf.NumberOfSelectedObjects(); i++)
                                {
                                    Grf.NewTempObject(Grf.Figure[Grf.SelectedObjects()[i]].GetTyp(), (i == 0));
                                    Grf.FigureTemp[i].Assign(Grf.Figure[Grf.SelectedObjects()[i]]);
                                    Grf.FigureTemp[i].Shift(-hSB.Value, -vSB.Value);
                                }
                            }
                            else
                            {
                                int dx = e.X - oldX;
                                int dy = e.Y - oldY;
                                oldX = e.X;
                                oldY = e.Y;
                                if ((Grf.Figure[Grf.SelectedObjects()[0]].State == BasicObject.StateTyp.edit) && (Grf.NumberOfSelectedObjects() == 1))
                                {
                                    Grf.FigureTemp[0].EditSize(nr, dx, dy);
                                }
                                else if ((Grf.Figure[Grf.SelectedObjects()[0]].State == BasicObject.StateTyp.rotate) && (Grf.NumberOfSelectedObjects() == 1))
                                {
                                    if (dx > 0)
                                    {
                                        Grf.FigureTemp[0].Rotate(2 * Math.PI / 180);
                                    }
                                    else if (dx < 0)
                                    {
                                        Grf.FigureTemp[0].Rotate(2 * Math.PI / -180);
                                    }
                                }
                                else
                                {
                                    for (int i = 0; i < Grf.NumberOfSelectedObjects(); i++)
                                    {
                                        Grf.FigureTemp[i].Shift(dx, dy);
                                    }
                                }
                                PictureBox.Refresh();
                            }
                        }
                        break;
                    }
            }
        }
        private void PictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            switch (Grf.State)
            {
                case Canvas.GraficState.grfNormal:
                    {
                        break;
                    }
                case Canvas.GraficState.grfDraw:
                    {
                        if ((e.Button == MouseButtons.Left) && (Grf.FigureTemp[0].NumberOfKnownPoints == true) && (DrawStep == Grf.FigureTemp[0].NumberOfPoints))
                        {
                            Grf.NewObject(Grf.FigureTemp[0].GetTyp());
                            Grf.FigureTemp[0].Shift(hSB.Value, vSB.Value);
                            Grf.FigureTemp[0].Ready = true;
                            Grf.Figure[Grf.NumberOfObjects - 1].Assign(Grf.FigureTemp[0]);
                            Grf.State = Canvas.GraficState.grfNormal;
                            FirstMove = true;
                            DrawNew();
                        }
                        break;
                    }
                case Canvas.GraficState.grfSelect:
                    {
                        if ((e.Button == MouseButtons.Left) && (Grf.NumberOfSelectedObjects() > 0) && (FirstMove != true))
                        {
                            for (int i = 0; i < Grf.NumberOfSelectedObjects(); i++)
                            {
                                Grf.FigureTemp[i].Shift(hSB.Value, vSB.Value);
                                Grf.Figure[Grf.SelectedObjects()[i]].Assign(Grf.FigureTemp[i]);
                                Grf.Figure[Grf.SelectedObjects()[i]].State = BasicObject.StateTyp.select;
                                FirstMove = true;
                                DrawNew();
                            }
                        }
                        break;
                    }
            }
        }
        private void editZOrder(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                int selectObject = Grf.SelectedObjects()[0];
                if (sender == InDenHintergrund) Grf.ObjectToBackground(selectObject);
                else if (sender == InToTheForeGround) Grf.ObjectToForeground(selectObject);
                else if (sender == InToTheBackGround) Grf.ObjectOnePositionToBackground(selectObject);
                else if (sender == ToFront) Grf.ObjectOnePositionToForeground(selectObject);
                DrawNew();
            }
        }
        private void PictureBox_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            switch (Grf.State)
            {
                case Canvas.GraficState.grfDraw:
                    {
                        if ((e.Button == MouseButtons.Left) && (Grf.FigureTemp[0].NumberOfKnownPoints == false))
                        {
                            Grf.NewObject(Grf.FigureTemp[0].GetTyp());
                            Grf.FigureTemp[0].Shift(hSB.Value, vSB.Value);
                            Grf.FigureTemp[0].Ready = true;
                            Grf.FigureTemp[0].NumberOfPoints = Grf.FigureTemp[0].NumberOfPoints - 1;
                            Grf.Figure[Grf.NumberOfObjects - 1].Assign(Grf.FigureTemp[0]);
                            Grf.State = Canvas.GraficState.grfNormal;
                            FirstMove = true;
                            DrawNew();
                        }
                        break;
                    }
            }
        }
        private void GraphicEditHandle()
        {
            DrawNew();
        }
        public void DrawBasic(BasicObject.ObjectTyp Typ, int More)
        {
            Grf.State = Canvas.GraficState.grfDraw;
            Grf.DeselectAll();
            Grf.NewTempObject(Typ, true,More);
            Grf.FigureTemp[0].Visible = false;
            DrawStep = 0;
        }
        private void Rotate(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                double angleDeg = double.Parse(((ToolStripMenuItem)sender).Tag.ToString());
                double angleRadian = Calculations.DegToRadian(angleDeg);
                int selectedObject = Grf.SelectedObjects()[0];
                Grf.Figure[selectedObject].Rotate(angleRadian);
                DrawNew();
            }
        }
        private void freAnglelToolStripMenuItem_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                Double angle = 0;
                try
                {
                    angle = Convert.ToDouble(TextBoxAngle.Text);
                }
                catch
                {
                    TextBoxAngle.Text = "0";
                }
                int selectedObject = Grf.SelectedObjects()[0];
                Grf.Figure[selectedObject].Rotate(Calculations.DegToRadian(angle));
                DrawNew();
            }
        }
        private void menuItemDrawClick(object sender, EventArgs e)
        {
            
            if (sender == menuItemEllipse)
            {
                DrawBasic(BasicObject.ObjectTyp.Ellypse, -1);
            }
            else if (sender == menuItemLinie)
            {
                DrawBasic(BasicObject.ObjectTyp.Line, -1);
            }
            else if (sender == menuItemDreieck)
            {
                DrawBasic(BasicObject.ObjectTyp.Triangle, -1);
            }
            else if (sender == menuItemKreis)
            {
                DrawBasic(BasicObject.ObjectTyp.Circle, -1);
            }
            else if (sender == menuItemRechteck)
            {
                DrawBasic(BasicObject.ObjectTyp.MyRectangle, -1);
            }
            else if (sender == menuItemQuadrat)
            {
                DrawBasic(BasicObject.ObjectTyp.Square, -1);
            }
            else
            {
                DrawBasic(BasicObject.ObjectTyp.Quadrangle, -1);
            }
        }

        private void exportToBitmapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveFileDialog.Filter = "Bitmap-Datei (*.bmp)|*.bmp|Graphics Interchange Format (*.gif)|*.gif|W3C Portable Network Graphics (*.png)|*.png|Joint Photographic Experts Group (*.jpg)|*.jpg|Tagged Image File Format (*.tif)|*.tif|Windows-Bildformat Erweiterte Metadatei (*emf)|*.emf";
            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                switch (saveFileDialog.FilterIndex)
                {
                    // the number of the first index is 1
                    case 1:
                    default:
                        btm.Save(saveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Bmp);
                        break;
                    case 2:
                        btm.Save(saveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Gif);
                        break;
                    case 3:
                        btm.Save(saveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Png);
                        break;
                    case 4:
                        btm.Save(saveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Jpeg);
                        break;
                    case 5:
                        btm.Save(saveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Tiff);
                        break;
                    case 6:
                        btm.Save(saveFileDialog.FileName, System.Drawing.Imaging.ImageFormat.Emf);
                        break;
                }
            }
        }

        private void pageSetupToolStripMenuItem_Click(object sender, EventArgs e)
        {
            pageSetupDialog.ShowDialog();
        }

        private void printPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ((Form)(printPreviewDialog)).WindowState = FormWindowState.Maximized;
            printPreviewDialog.ShowDialog();
        }

        private void printDocument_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            Rectangle srcRect = new Rectangle(printDocument.DefaultPageSettings.Margins.Left, printDocument.DefaultPageSettings.Margins.Top, printDocument.DefaultPageSettings.Bounds.Width - printDocument.DefaultPageSettings.Margins.Right - printDocument.DefaultPageSettings.Margins.Left, printDocument.DefaultPageSettings.Bounds.Height - printDocument.DefaultPageSettings.Margins.Bottom - printDocument.DefaultPageSettings.Margins.Top);
            e.Graphics.DrawImage(btm, srcRect);
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (printDialog.ShowDialog() == DialogResult.OK)
            {
                printDocument.Print();
            }
        }
    }
}